package ui.cursors
{
	public class CursorStack 
	{		
		public function CursorStack() 
		{
		}
		
		public var onChange:Function;
		
		private var _cursor:Cursor;
		public function get cursor():Cursor
		{
			return _cursor;
		}
		
		private function setCursor(cursor:Cursor):void
		{
			if (_cursor != cursor)
			{
				_cursor = cursor;
				if (onChange != null)
				{
					onChange();
				}
			}
		}
		
		internal var switchers:Array = [];
		
		internal function add(switcher:Switcher):void
		{
			var index:int = switchers.indexOf(switcher);
			if (index != -1)
			{
				switchers.splice(index, 1);
			}
			var priority:int = switcher.priority;
			var i:int = switchers.length;
			while (i-- > 0)
			{
				var switcherI:Switcher = switchers[i];
				if (priority >= switcherI.priority)
				{
					break;
				}
			}
			i++;
			switchers.splice(i, 0, switcher);
			updateSwitcher();
		}
		
		internal function remove(switcher:Switcher):void
		{
			var index:int = switchers.indexOf(switcher);
			if (index != -1)
			{
				switchers.splice(index, 1);
			}
			updateSwitcher();
		}
		
		private var _mainSwitcher:Switcher;
		
		private function updateSwitcher():void
		{
			if (_mainSwitcher != null)
			{
				_mainSwitcher.onChange = null;
			}
			_mainSwitcher = switchers[switchers.length - 1];
			if (_mainSwitcher != null)
			{
				_mainSwitcher.onChange = onSwitcherChange;
			}
			setCursor(_mainSwitcher != null ? _mainSwitcher.cursor : null);
		}
		
		private function onSwitcherChange():void
		{
			setCursor(_mainSwitcher.cursor);
		}
	}
}