package ui.cursors
{
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;

	public class HoverSwitcher extends Switcher
	{
		public function HoverSwitcher(stack:CursorStack, priority:int) 
		{
			super(stack, priority);
		}
		
		private var _target:DisplayObject;
		public function get target():DisplayObject
		{
			return _target;
		}
		
		public function set target(value:DisplayObject):void
		{
			if (_target != null)
			{
				_target.removeEventListener(MouseEvent.ROLL_OVER, onRollOver);
				_target.removeEventListener(MouseEvent.ROLL_OUT, onRollOut);
			}
			_target = value;
			if (_target != null)
			{
				_target.addEventListener(MouseEvent.ROLL_OVER, onRollOver);
				_target.addEventListener(MouseEvent.ROLL_OUT, onRollOut);
			}
			else
			{
				enabled = false;
			}
		}
		
		/**
		 * Для установки объекта курсора в fluent-стиле программирования
		 * @param	target
		 * @return
		 */
		public function setTarget(target:DisplayObject):HoverSwitcher
		{
			this.target = target;
			return this;
		}
		
		private function onRollOver(event:MouseEvent):void
		{
			enabled = true;
		}
		
		private function onRollOut(event:MouseEvent):void
		{
			enabled = false;
		}
	}
}