package ui.cursors
{
	public class Switcher 
	{
		private var _stack:CursorStack;
		
		public function Switcher(stack:CursorStack, priority:int = 0) 
		{
			_stack = stack;
			_priority = priority;
		}
		
		private var _priority:int;
		public function get priority():int
		{
			return _priority;
		}
		
		internal var onChange:Function;
		
		private var _cursor:Cursor;
		public function get cursor():Cursor
		{
			return _cursor;
		}
		public function set cursor(value:Cursor):void
		{
			_cursor = value;
			if (onChange != null)
			{
				onChange();
			}
		}
		
		/**
		 * Для установки курсора в fluent-стиле программирования
		 * @param	cursor
		 * @return
		 */
		public function setCursor(cursor:Cursor):Switcher
		{
			this.cursor = cursor;
			return this;
		}
		
		private var _enabled:Boolean = false;
		public function get enabled():Boolean
		{
			return _enabled;
		}
		public function set enabled(value:Boolean):void
		{
			_enabled = value;
			if (_enabled)
			{
				_stack.add(this);
			}
			else
			{
				_stack.remove(this);
			}
		}
	}
}